;;; color-mate-face.el -- Coloring mule/emacs to more easier and more fun.

;; Copyright (C) YOKOTA Hiroshi

;; Author: YOKOTA Hiroshi <yokota@netlab.is.tsukuba.ac.jp>
;; Maintainer: YOKOTA Hiroshi <yokota@netlab.is.tsukuba.ac.jp>
;; Version: 10.0
;; Keywords: color hilit19 font-lock color-mate paren
;; Content-Type: text/plain; charset=x-euc-jp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;   Color-Mate  Ver.10.0
;;         by  ͵ (yokota@netlab.is.tsukuba.ac.jp)
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;   Coloring mule/emacs to more easier and more fun.
;;   mule / emacs ǡѤƸ䤹̤ˤޤ
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;; Commentary:
;; (1) This Library require hilit19.el and font-lock.el.
;; (2) Write these lines to your ~/.emacs
;;        (if (and (>= (string-to-int emacs-version) 19)
;;	           window-system )
;;            (progn
;;               (require 'color-mate-face)
;;               (color-mate-face)
;;               ))
;;     or Add "color-mate.emacs.add"'s contents to your ~/.emacs
;;
;;  If you use mule, and you want to more, see skk-cursor.el, egg-cursor.el,
;; canna-cursor.el and sj3-cursor.el

;$Id: color-mate-face.el,v 10.1 1999/08/05 23:14:40 elca Exp $

;; -*-mode: emacs-lisp-*-

;;; Code:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;                          ʸؤ忧
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; hilit19  font-lock Ȥäʸ忧롣
;; Canna ȤäƤʤ顢 Canna 忧ǽͭˤ롣
;;

;; hilit19, font-lock Ѥɲꡣ (mule FAQ )

; Color-Mate  hilit19  font-lock Ʊ˻ѤƤΤǡ
; δ֤ǤĴΤʸΥ顼򾡼˽񤭴Ƥޤ
; ⤷ʤ hilit19  font-lock ȤäƤʤ顢꤬Ѥä
; ޤ줬ޤλ .emacs ˵Ҥ줿
;
;   (require 'color-mate-face)
;
; ƤεǽȤʤ褦ˤƲ

(require 'color-mate-util)

(defun color-mate:face ()
  "Color-Mate's face utility routine. This routine use with Color-Mate."
  (interactive)
  (progn
    ;; ưå
    (message "Loading Color-Mate face utility...")


    ;; xemacs Ǥ hilit19.el ϻȤʤ褦
    (if (not (color-mate:is-xemacs))
	(color-mate:face:hilight))

    (color-mate:face:paren)
    ;(color-mate:face:region)
    (color-mate:face:kanakan)

    ;; ưλå
    (message "Loading Color-Mate face utility...done")
    ))


(defun color-mate:face:hilight ()
  (progn
    (progn

      ;;----------------;
      ;; hilit19 
      ;;----------------;
      (require 'hilit19)		; ʸ˿դ

      ;;
      ;; hilit19 ɲ忧
      ;;
      ;; hilit-translate ϴؿǤϤʤޥǤΤǥХȥѥ
      ;; emacs/mule ˥ޥǤǧɬפ롣
      ;; ܤ color-mate-compile.el 򻲾ȡ
      ;;
      ;; ø int ʤɤѿؤ忧
      (hilit-translate type     'RoyalBlue)
      ))

  ;;------------------;
  ;; font-lock 
  ;;------------------;
  ;;
  (require 'font-lock)		; ʸ˿դ

  ;; Ť emacs/mule °Ƥ font-lock.el ˤ font-lock-mode 
  ;; ưƤӤ롼󤬤ʤΤɲä롣
  (if (string< emacs-version "19.29")
      (defun turn-on-font-lock ()
	"Hook routine for font-lock. (By color-mate-face.el)"
	(font-lock-mode 1)))

  ;; font-lock.el ˤʸ忧ư
  (add-hook 'find-file-hooks 'turn-on-font-lock)

  ;;
  ;; hilit19 Ʊˤʤ褦ˤ
  ;;
  ;; mule  emacs Ƕ̤˻Ȥ褦ʥܡɥեȤץब
  ;; ޤưʤʤȤʤʤΤ
  (if (boundp 'MULE)
      ;; mule ѤΥ롼
      (progn
	(add-hook 'font-lock-mode-hook
		  '(lambda ()
		     ;; øˤ define ѿ̾ʤ
		     (make-face           'keyword-face)
		     (set-face-foreground 'keyword-face "purple")
		     (set-face-bold-p     'keyword-face t)
		     (setq font-lock-keyword-face 'keyword-face)

		     ;; 
		     (make-face           'comment-face)
		     (set-face-foreground 'comment-face "firebrick")
		     (setq font-lock-comment-face 'comment-face)

		     ;; ʸ
		     (make-face            'string-face)
		     (set-face-foreground  'string-face "grey40")
		     (set-face-underline-p 'string-face t)
		     (setq font-lock-string-face 'string-face)

		     ;; ؿ̾
		     (make-face           'function-face)
		     (set-face-foreground 'function-face "blue")
		     (set-face-bold-p     'function-face t)
		     (setq font-lock-function-name-face 'function-face)

		     ;; ѿ
		     (make-face           'c-type-face)
		     (set-face-foreground 'c-type-face "RoyalBlue")
		     (setq font-lock-type-face 'c-type-face)
		     ))
	)

    ;; emacs ѤΥ롼
    ;; xemacs ǤϤޤưƤʤ褦
    (progn
      ;; եȺ
      (make-face            'keyword-face)
      (set-face-foreground  'keyword-face "purple")
      (make-face-bold       'keyword-face)

      (make-face            'comment-face)
      (set-face-foreground  'comment-face "firebrick")

      (make-face            'string-face)
      (set-face-foreground  'string-face "grey40")
      (set-face-underline-p 'string-face t)

      (make-face            'function-face)
      (set-face-foreground  'function-face "blue")
      (make-face-bold       'function-face)

      (make-face            'c-type-face)
      (set-face-foreground  'c-type-face "RoyalBlue")

      ;; 
      (add-hook 'font-lock-mode-hook
		'(lambda ()
		   ;; øˤ define ѿ̾ʤ
		   (setq font-lock-keyword-face       'keyword-face)

		   ;; 
		   (setq font-lock-comment-face       'comment-face)

		   ;; ʸ
		   (setq font-lock-string-face        'string-face)

		   ;; ؿ̾
		   (setq font-lock-function-name-face 'function-face)

		   ;; ѿ
		   (setq font-lock-type-face          'c-type-face)
		   ))
      )))


(defun color-mate:face:paren ()
  (progn
    ;;--------------;
    ;; paren 
    ;;--------------;
    (require 'paren)
    (if (color-mate:is-xemacs)
	(if (< (color-mate:emacs-version) 20)
	    (setq paren-mode 'sexp) ; xemacs 19
	  (paren-set-mode 'sexp)))  ; xemacs 20
    (if (and (>= (color-mate:emacs-version) 20) ; emacs 20
	     (not (color-mate:is-xemacs)))
	(custom-set-variables
	 '(show-paren-style 'mixed)
	 '(show-paren-mode t nil (paren))))

    ))


(defun color-mate:face:region ()
  (progn
    ;;------------------------;
    ;; ꡼Ļ벽
    ;;------------------------;
    (setq transient-mark-mode t)
    ))

(defun color-mate:face:kanakan ()
  (progn
    ;;------------------------;
    ;; ̾Ѵΰ忧
    ;;------------------------;

    ;; canna 忧ǽͭˤ롣
    ;; Canna  mule Ǥ canna.el ˤ˥ɤƤΤ
    ;; (featurep 'canna) Ǥ (canna) ¹Ԥʬʤ
    ;; Ǥɤʬʤ canna-empty-info
    ;; Ȥѿ Canna ư t ˤʤѤ
    ;; 桼 Canna ȤäƤ뤫(˵ưƤ뤫)Ƚꤹ롣

    ; mule
    (if (and (boundp 'CANNA)
	     canna-empty-info)
	(progn
	  (setq canna-use-color t)
	  (progn
	    (cond
		 ((boundp 'egg-version)
		  (require 'can-n-egg)
		  (can-n-egg))
		 (t
		  (require 'canna)
		  (canna))
		 ))))
    ; emacs20 / xemacs20
    (if (>= (color-mate:emacs-version) 20)
	  (setq canna-use-color t))



    ;; face Ѱ
    ;; Ѵΰ
    (make-face           'color-mate:firebrick1)
    (set-face-foreground 'color-mate:firebrick1 "firebrick1")
    ;; ܤñ
    (make-face           'color-mate:RoyalBlue2-lavender)
    (set-face-foreground 'color-mate:RoyalBlue2-lavender "RoyalBlue2")
    (set-face-background 'color-mate:RoyalBlue2-lavender "lavender")


    ;; skk 忧ǽ (mule/xemacs)
    ;; Ѵʸο canna Ʊˤ
    (if (or (fboundp 'skk-mode)
	    (color-mate:is-xemacs))
	(progn
	  (setq skk-use-face t)
	  (setq skk-henkan-face 'color-mate:RoyalBlue2-lavender)))

    ;; skk 9.6 ξϤɤ
;    (if (fboundp 'skk-mode)
;	(progn
;	  (require 'skk-e19)
;	  (skk-make-face 'RoyalBlue2/lavender)
;	  (setq skk-henkan-face 'RoyalBlue2/lavender)))

    ;; emacs 20  skk ⡼
    (if (and (not (color-mate:is-xemacs))
	     (>= (color-mate:emacs-version) 20))
	(progn
	  (setq kkc-overlay-head (make-overlay 0 0 nil nil t))
	  (overlay-put kkc-overlay-head 'face 'color-mate:RoyalBlue2-lavender)
	  (delete-overlay kkc-overlay-head)
	  (setq quail-conv-overlay (make-overlay 0 0 nil nil t))
	  (overlay-put quail-conv-overlay  'face 'color-mate:firebrick1)
	  (delete-overlay quail-conv-overlay)
	  ))


    ;; wnn 忧ǽ
    ;; canna 忧Ʊ褦ˤ
    (if (or (boundp 'WNN)
	    (>= (color-mate:emacs-version) 20))
	(progn
	  (setq egg:*fence-face*         'color-mate:firebrick1)
	  (setq egg:*henkan-face*        'color-mate:firebrick1)
	  (setq egg:*fence-face-in-cont* 'color-mate:RoyalBlue2-lavender)
	  (setq egg:*dai-bunsetu-face*   'color-mate:RoyalBlue2-lavender)
	  (setq egg:*sho-bunsetu-face*   'color-mate:RoyalBlue2-lavender)
	  ))

    ;; sj3 忧ǽ
    ;; canna 忧Ʊ褦ˤ
    ;; ޤĤʤ
    (if (boundp 'SJ3)
	(progn
	  (setq egg:*fence-face*         'color-mate:firebrick1)
	  (setq egg:*henkan-face*        'color-mate:firebrick1)
	  (setq egg:*fence-face-in-cont* 'color-mate:RoyalBlue2-lavender)
	  ))
    ))

(provide 'color-mate-face) ; feature ȤϿ

;;; color-mate-face.el ends here
